// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from canopen_inventus_interfaces:msg/Status.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "canopen_inventus_interfaces/msg/status.hpp"


#ifndef CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__STATUS__BUILDER_HPP_
#define CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__STATUS__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "canopen_inventus_interfaces/msg/detail/status__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace canopen_inventus_interfaces
{

namespace msg
{

namespace builder
{

class Init_Status_discharge_fault
{
public:
  explicit Init_Status_discharge_fault(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  ::canopen_inventus_interfaces::msg::Status discharge_fault(::canopen_inventus_interfaces::msg::Status::_discharge_fault_type arg)
  {
    msg_.discharge_fault = std::move(arg);
    return std::move(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_charge_fault
{
public:
  explicit Init_Status_charge_fault(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_discharge_fault charge_fault(::canopen_inventus_interfaces::msg::Status::_charge_fault_type arg)
  {
    msg_.charge_fault = std::move(arg);
    return Init_Status_discharge_fault(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_op_mode
{
public:
  explicit Init_Status_op_mode(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_charge_fault op_mode(::canopen_inventus_interfaces::msg::Status::_op_mode_type arg)
  {
    msg_.op_mode = std::move(arg);
    return Init_Status_charge_fault(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_cell_voltage
{
public:
  explicit Init_Status_cell_voltage(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_op_mode cell_voltage(::canopen_inventus_interfaces::msg::Status::_cell_voltage_type arg)
  {
    msg_.cell_voltage = std::move(arg);
    return Init_Status_op_mode(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_remaining_capacity
{
public:
  explicit Init_Status_remaining_capacity(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_cell_voltage remaining_capacity(::canopen_inventus_interfaces::msg::Status::_remaining_capacity_type arg)
  {
    msg_.remaining_capacity = std::move(arg);
    return Init_Status_cell_voltage(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_design_capacity
{
public:
  explicit Init_Status_design_capacity(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_remaining_capacity design_capacity(::canopen_inventus_interfaces::msg::Status::_design_capacity_type arg)
  {
    msg_.design_capacity = std::move(arg);
    return Init_Status_remaining_capacity(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_full_charge_capacity
{
public:
  explicit Init_Status_full_charge_capacity(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_design_capacity full_charge_capacity(::canopen_inventus_interfaces::msg::Status::_full_charge_capacity_type arg)
  {
    msg_.full_charge_capacity = std::move(arg);
    return Init_Status_design_capacity(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_state_of_charge
{
public:
  explicit Init_Status_state_of_charge(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_full_charge_capacity state_of_charge(::canopen_inventus_interfaces::msg::Status::_state_of_charge_type arg)
  {
    msg_.state_of_charge = std::move(arg);
    return Init_Status_full_charge_capacity(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_max_cell_temperature
{
public:
  explicit Init_Status_max_cell_temperature(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_state_of_charge max_cell_temperature(::canopen_inventus_interfaces::msg::Status::_max_cell_temperature_type arg)
  {
    msg_.max_cell_temperature = std::move(arg);
    return Init_Status_state_of_charge(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_min_cell_temperature
{
public:
  explicit Init_Status_min_cell_temperature(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_max_cell_temperature min_cell_temperature(::canopen_inventus_interfaces::msg::Status::_min_cell_temperature_type arg)
  {
    msg_.min_cell_temperature = std::move(arg);
    return Init_Status_max_cell_temperature(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_temperature
{
public:
  explicit Init_Status_temperature(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_min_cell_temperature temperature(::canopen_inventus_interfaces::msg::Status::_temperature_type arg)
  {
    msg_.temperature = std::move(arg);
    return Init_Status_min_cell_temperature(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_voltage
{
public:
  explicit Init_Status_voltage(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_temperature voltage(::canopen_inventus_interfaces::msg::Status::_voltage_type arg)
  {
    msg_.voltage = std::move(arg);
    return Init_Status_temperature(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_current
{
public:
  explicit Init_Status_current(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_voltage current(::canopen_inventus_interfaces::msg::Status::_current_type arg)
  {
    msg_.current = std::move(arg);
    return Init_Status_voltage(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_serial_number
{
public:
  explicit Init_Status_serial_number(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_current serial_number(::canopen_inventus_interfaces::msg::Status::_serial_number_type arg)
  {
    msg_.serial_number = std::move(arg);
    return Init_Status_current(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_firmware_version
{
public:
  explicit Init_Status_firmware_version(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_serial_number firmware_version(::canopen_inventus_interfaces::msg::Status::_firmware_version_type arg)
  {
    msg_.firmware_version = std::move(arg);
    return Init_Status_serial_number(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_software_version
{
public:
  explicit Init_Status_software_version(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_firmware_version software_version(::canopen_inventus_interfaces::msg::Status::_software_version_type arg)
  {
    msg_.software_version = std::move(arg);
    return Init_Status_firmware_version(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_hardware_version
{
public:
  explicit Init_Status_hardware_version(::canopen_inventus_interfaces::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_software_version hardware_version(::canopen_inventus_interfaces::msg::Status::_hardware_version_type arg)
  {
    msg_.hardware_version = std::move(arg);
    return Init_Status_software_version(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

class Init_Status_header
{
public:
  Init_Status_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Status_hardware_version header(::canopen_inventus_interfaces::msg::Status::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_Status_hardware_version(msg_);
  }

private:
  ::canopen_inventus_interfaces::msg::Status msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::canopen_inventus_interfaces::msg::Status>()
{
  return canopen_inventus_interfaces::msg::builder::Init_Status_header();
}

}  // namespace canopen_inventus_interfaces

#endif  // CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__STATUS__BUILDER_HPP_
