// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from canopen_inventus_interfaces:msg/Status.idl
// generated code does not contain a copyright notice
#include "canopen_inventus_interfaces/msg/detail/status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `hardware_version`
// Member `software_version`
// Member `firmware_version`
// Member `serial_number`
#include "rosidl_runtime_c/string_functions.h"
// Member `cell_voltage`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
canopen_inventus_interfaces__msg__Status__init(canopen_inventus_interfaces__msg__Status * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    canopen_inventus_interfaces__msg__Status__fini(msg);
    return false;
  }
  // hardware_version
  if (!rosidl_runtime_c__String__init(&msg->hardware_version)) {
    canopen_inventus_interfaces__msg__Status__fini(msg);
    return false;
  }
  // software_version
  if (!rosidl_runtime_c__String__init(&msg->software_version)) {
    canopen_inventus_interfaces__msg__Status__fini(msg);
    return false;
  }
  // firmware_version
  if (!rosidl_runtime_c__String__init(&msg->firmware_version)) {
    canopen_inventus_interfaces__msg__Status__fini(msg);
    return false;
  }
  // serial_number
  if (!rosidl_runtime_c__String__init(&msg->serial_number)) {
    canopen_inventus_interfaces__msg__Status__fini(msg);
    return false;
  }
  // current
  // voltage
  // temperature
  // min_cell_temperature
  // max_cell_temperature
  // state_of_charge
  // full_charge_capacity
  // design_capacity
  // remaining_capacity
  // cell_voltage
  if (!rosidl_runtime_c__float__Sequence__init(&msg->cell_voltage, 0)) {
    canopen_inventus_interfaces__msg__Status__fini(msg);
    return false;
  }
  // op_mode
  // charge_fault
  // discharge_fault
  return true;
}

void
canopen_inventus_interfaces__msg__Status__fini(canopen_inventus_interfaces__msg__Status * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // hardware_version
  rosidl_runtime_c__String__fini(&msg->hardware_version);
  // software_version
  rosidl_runtime_c__String__fini(&msg->software_version);
  // firmware_version
  rosidl_runtime_c__String__fini(&msg->firmware_version);
  // serial_number
  rosidl_runtime_c__String__fini(&msg->serial_number);
  // current
  // voltage
  // temperature
  // min_cell_temperature
  // max_cell_temperature
  // state_of_charge
  // full_charge_capacity
  // design_capacity
  // remaining_capacity
  // cell_voltage
  rosidl_runtime_c__float__Sequence__fini(&msg->cell_voltage);
  // op_mode
  // charge_fault
  // discharge_fault
}

bool
canopen_inventus_interfaces__msg__Status__are_equal(const canopen_inventus_interfaces__msg__Status * lhs, const canopen_inventus_interfaces__msg__Status * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // hardware_version
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->hardware_version), &(rhs->hardware_version)))
  {
    return false;
  }
  // software_version
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->software_version), &(rhs->software_version)))
  {
    return false;
  }
  // firmware_version
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->firmware_version), &(rhs->firmware_version)))
  {
    return false;
  }
  // serial_number
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->serial_number), &(rhs->serial_number)))
  {
    return false;
  }
  // current
  if (lhs->current != rhs->current) {
    return false;
  }
  // voltage
  if (lhs->voltage != rhs->voltage) {
    return false;
  }
  // temperature
  if (lhs->temperature != rhs->temperature) {
    return false;
  }
  // min_cell_temperature
  if (lhs->min_cell_temperature != rhs->min_cell_temperature) {
    return false;
  }
  // max_cell_temperature
  if (lhs->max_cell_temperature != rhs->max_cell_temperature) {
    return false;
  }
  // state_of_charge
  if (lhs->state_of_charge != rhs->state_of_charge) {
    return false;
  }
  // full_charge_capacity
  if (lhs->full_charge_capacity != rhs->full_charge_capacity) {
    return false;
  }
  // design_capacity
  if (lhs->design_capacity != rhs->design_capacity) {
    return false;
  }
  // remaining_capacity
  if (lhs->remaining_capacity != rhs->remaining_capacity) {
    return false;
  }
  // cell_voltage
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->cell_voltage), &(rhs->cell_voltage)))
  {
    return false;
  }
  // op_mode
  if (lhs->op_mode != rhs->op_mode) {
    return false;
  }
  // charge_fault
  if (lhs->charge_fault != rhs->charge_fault) {
    return false;
  }
  // discharge_fault
  if (lhs->discharge_fault != rhs->discharge_fault) {
    return false;
  }
  return true;
}

bool
canopen_inventus_interfaces__msg__Status__copy(
  const canopen_inventus_interfaces__msg__Status * input,
  canopen_inventus_interfaces__msg__Status * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // hardware_version
  if (!rosidl_runtime_c__String__copy(
      &(input->hardware_version), &(output->hardware_version)))
  {
    return false;
  }
  // software_version
  if (!rosidl_runtime_c__String__copy(
      &(input->software_version), &(output->software_version)))
  {
    return false;
  }
  // firmware_version
  if (!rosidl_runtime_c__String__copy(
      &(input->firmware_version), &(output->firmware_version)))
  {
    return false;
  }
  // serial_number
  if (!rosidl_runtime_c__String__copy(
      &(input->serial_number), &(output->serial_number)))
  {
    return false;
  }
  // current
  output->current = input->current;
  // voltage
  output->voltage = input->voltage;
  // temperature
  output->temperature = input->temperature;
  // min_cell_temperature
  output->min_cell_temperature = input->min_cell_temperature;
  // max_cell_temperature
  output->max_cell_temperature = input->max_cell_temperature;
  // state_of_charge
  output->state_of_charge = input->state_of_charge;
  // full_charge_capacity
  output->full_charge_capacity = input->full_charge_capacity;
  // design_capacity
  output->design_capacity = input->design_capacity;
  // remaining_capacity
  output->remaining_capacity = input->remaining_capacity;
  // cell_voltage
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->cell_voltage), &(output->cell_voltage)))
  {
    return false;
  }
  // op_mode
  output->op_mode = input->op_mode;
  // charge_fault
  output->charge_fault = input->charge_fault;
  // discharge_fault
  output->discharge_fault = input->discharge_fault;
  return true;
}

canopen_inventus_interfaces__msg__Status *
canopen_inventus_interfaces__msg__Status__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  canopen_inventus_interfaces__msg__Status * msg = (canopen_inventus_interfaces__msg__Status *)allocator.allocate(sizeof(canopen_inventus_interfaces__msg__Status), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(canopen_inventus_interfaces__msg__Status));
  bool success = canopen_inventus_interfaces__msg__Status__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
canopen_inventus_interfaces__msg__Status__destroy(canopen_inventus_interfaces__msg__Status * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    canopen_inventus_interfaces__msg__Status__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
canopen_inventus_interfaces__msg__Status__Sequence__init(canopen_inventus_interfaces__msg__Status__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  canopen_inventus_interfaces__msg__Status * data = NULL;

  if (size) {
    data = (canopen_inventus_interfaces__msg__Status *)allocator.zero_allocate(size, sizeof(canopen_inventus_interfaces__msg__Status), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = canopen_inventus_interfaces__msg__Status__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        canopen_inventus_interfaces__msg__Status__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
canopen_inventus_interfaces__msg__Status__Sequence__fini(canopen_inventus_interfaces__msg__Status__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      canopen_inventus_interfaces__msg__Status__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

canopen_inventus_interfaces__msg__Status__Sequence *
canopen_inventus_interfaces__msg__Status__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  canopen_inventus_interfaces__msg__Status__Sequence * array = (canopen_inventus_interfaces__msg__Status__Sequence *)allocator.allocate(sizeof(canopen_inventus_interfaces__msg__Status__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = canopen_inventus_interfaces__msg__Status__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
canopen_inventus_interfaces__msg__Status__Sequence__destroy(canopen_inventus_interfaces__msg__Status__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    canopen_inventus_interfaces__msg__Status__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
canopen_inventus_interfaces__msg__Status__Sequence__are_equal(const canopen_inventus_interfaces__msg__Status__Sequence * lhs, const canopen_inventus_interfaces__msg__Status__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!canopen_inventus_interfaces__msg__Status__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
canopen_inventus_interfaces__msg__Status__Sequence__copy(
  const canopen_inventus_interfaces__msg__Status__Sequence * input,
  canopen_inventus_interfaces__msg__Status__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(canopen_inventus_interfaces__msg__Status);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    canopen_inventus_interfaces__msg__Status * data =
      (canopen_inventus_interfaces__msg__Status *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!canopen_inventus_interfaces__msg__Status__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          canopen_inventus_interfaces__msg__Status__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!canopen_inventus_interfaces__msg__Status__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
