// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from canopen_inventus_interfaces:msg/VirtualBattery.idl
// generated code does not contain a copyright notice
#include "canopen_inventus_interfaces/msg/detail/virtual_battery__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
canopen_inventus_interfaces__msg__VirtualBattery__init(canopen_inventus_interfaces__msg__VirtualBattery * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    canopen_inventus_interfaces__msg__VirtualBattery__fini(msg);
    return false;
  }
  // number_of_batteries
  // soc
  // sum_capacity
  // remaining_runtime
  // remaining_chargetime
  // avg_voltage
  // sum_current
  // discharge_current_limit
  // charge_cutoff_current
  // fully_charged
  // avg_temp
  // discharge_cutoff_voltage
  // charge_current_limit
  // max_voltage_allowed
  // avg_health
  // num_faulted_batteries
  // num_active_batteries
  // op_mode
  // charge_fault
  // discharge_fault
  // regen_current_limit
  // min_cell_voltage
  // max_cell_voltage
  // cell_balance_status
  // all_avg_voltage
  // all_soc
  // all_avg_temp
  // master_node_id
  // avail_op_modes
  // avail_charge_faults
  // avail_discharge_faults
  return true;
}

void
canopen_inventus_interfaces__msg__VirtualBattery__fini(canopen_inventus_interfaces__msg__VirtualBattery * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // number_of_batteries
  // soc
  // sum_capacity
  // remaining_runtime
  // remaining_chargetime
  // avg_voltage
  // sum_current
  // discharge_current_limit
  // charge_cutoff_current
  // fully_charged
  // avg_temp
  // discharge_cutoff_voltage
  // charge_current_limit
  // max_voltage_allowed
  // avg_health
  // num_faulted_batteries
  // num_active_batteries
  // op_mode
  // charge_fault
  // discharge_fault
  // regen_current_limit
  // min_cell_voltage
  // max_cell_voltage
  // cell_balance_status
  // all_avg_voltage
  // all_soc
  // all_avg_temp
  // master_node_id
  // avail_op_modes
  // avail_charge_faults
  // avail_discharge_faults
}

bool
canopen_inventus_interfaces__msg__VirtualBattery__are_equal(const canopen_inventus_interfaces__msg__VirtualBattery * lhs, const canopen_inventus_interfaces__msg__VirtualBattery * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // number_of_batteries
  if (lhs->number_of_batteries != rhs->number_of_batteries) {
    return false;
  }
  // soc
  if (lhs->soc != rhs->soc) {
    return false;
  }
  // sum_capacity
  if (lhs->sum_capacity != rhs->sum_capacity) {
    return false;
  }
  // remaining_runtime
  if (lhs->remaining_runtime != rhs->remaining_runtime) {
    return false;
  }
  // remaining_chargetime
  if (lhs->remaining_chargetime != rhs->remaining_chargetime) {
    return false;
  }
  // avg_voltage
  if (lhs->avg_voltage != rhs->avg_voltage) {
    return false;
  }
  // sum_current
  if (lhs->sum_current != rhs->sum_current) {
    return false;
  }
  // discharge_current_limit
  if (lhs->discharge_current_limit != rhs->discharge_current_limit) {
    return false;
  }
  // charge_cutoff_current
  if (lhs->charge_cutoff_current != rhs->charge_cutoff_current) {
    return false;
  }
  // fully_charged
  if (lhs->fully_charged != rhs->fully_charged) {
    return false;
  }
  // avg_temp
  if (lhs->avg_temp != rhs->avg_temp) {
    return false;
  }
  // discharge_cutoff_voltage
  if (lhs->discharge_cutoff_voltage != rhs->discharge_cutoff_voltage) {
    return false;
  }
  // charge_current_limit
  if (lhs->charge_current_limit != rhs->charge_current_limit) {
    return false;
  }
  // max_voltage_allowed
  if (lhs->max_voltage_allowed != rhs->max_voltage_allowed) {
    return false;
  }
  // avg_health
  if (lhs->avg_health != rhs->avg_health) {
    return false;
  }
  // num_faulted_batteries
  if (lhs->num_faulted_batteries != rhs->num_faulted_batteries) {
    return false;
  }
  // num_active_batteries
  if (lhs->num_active_batteries != rhs->num_active_batteries) {
    return false;
  }
  // op_mode
  if (lhs->op_mode != rhs->op_mode) {
    return false;
  }
  // charge_fault
  if (lhs->charge_fault != rhs->charge_fault) {
    return false;
  }
  // discharge_fault
  if (lhs->discharge_fault != rhs->discharge_fault) {
    return false;
  }
  // regen_current_limit
  if (lhs->regen_current_limit != rhs->regen_current_limit) {
    return false;
  }
  // min_cell_voltage
  if (lhs->min_cell_voltage != rhs->min_cell_voltage) {
    return false;
  }
  // max_cell_voltage
  if (lhs->max_cell_voltage != rhs->max_cell_voltage) {
    return false;
  }
  // cell_balance_status
  if (lhs->cell_balance_status != rhs->cell_balance_status) {
    return false;
  }
  // all_avg_voltage
  if (lhs->all_avg_voltage != rhs->all_avg_voltage) {
    return false;
  }
  // all_soc
  if (lhs->all_soc != rhs->all_soc) {
    return false;
  }
  // all_avg_temp
  if (lhs->all_avg_temp != rhs->all_avg_temp) {
    return false;
  }
  // master_node_id
  if (lhs->master_node_id != rhs->master_node_id) {
    return false;
  }
  // avail_op_modes
  if (lhs->avail_op_modes != rhs->avail_op_modes) {
    return false;
  }
  // avail_charge_faults
  if (lhs->avail_charge_faults != rhs->avail_charge_faults) {
    return false;
  }
  // avail_discharge_faults
  if (lhs->avail_discharge_faults != rhs->avail_discharge_faults) {
    return false;
  }
  return true;
}

bool
canopen_inventus_interfaces__msg__VirtualBattery__copy(
  const canopen_inventus_interfaces__msg__VirtualBattery * input,
  canopen_inventus_interfaces__msg__VirtualBattery * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // number_of_batteries
  output->number_of_batteries = input->number_of_batteries;
  // soc
  output->soc = input->soc;
  // sum_capacity
  output->sum_capacity = input->sum_capacity;
  // remaining_runtime
  output->remaining_runtime = input->remaining_runtime;
  // remaining_chargetime
  output->remaining_chargetime = input->remaining_chargetime;
  // avg_voltage
  output->avg_voltage = input->avg_voltage;
  // sum_current
  output->sum_current = input->sum_current;
  // discharge_current_limit
  output->discharge_current_limit = input->discharge_current_limit;
  // charge_cutoff_current
  output->charge_cutoff_current = input->charge_cutoff_current;
  // fully_charged
  output->fully_charged = input->fully_charged;
  // avg_temp
  output->avg_temp = input->avg_temp;
  // discharge_cutoff_voltage
  output->discharge_cutoff_voltage = input->discharge_cutoff_voltage;
  // charge_current_limit
  output->charge_current_limit = input->charge_current_limit;
  // max_voltage_allowed
  output->max_voltage_allowed = input->max_voltage_allowed;
  // avg_health
  output->avg_health = input->avg_health;
  // num_faulted_batteries
  output->num_faulted_batteries = input->num_faulted_batteries;
  // num_active_batteries
  output->num_active_batteries = input->num_active_batteries;
  // op_mode
  output->op_mode = input->op_mode;
  // charge_fault
  output->charge_fault = input->charge_fault;
  // discharge_fault
  output->discharge_fault = input->discharge_fault;
  // regen_current_limit
  output->regen_current_limit = input->regen_current_limit;
  // min_cell_voltage
  output->min_cell_voltage = input->min_cell_voltage;
  // max_cell_voltage
  output->max_cell_voltage = input->max_cell_voltage;
  // cell_balance_status
  output->cell_balance_status = input->cell_balance_status;
  // all_avg_voltage
  output->all_avg_voltage = input->all_avg_voltage;
  // all_soc
  output->all_soc = input->all_soc;
  // all_avg_temp
  output->all_avg_temp = input->all_avg_temp;
  // master_node_id
  output->master_node_id = input->master_node_id;
  // avail_op_modes
  output->avail_op_modes = input->avail_op_modes;
  // avail_charge_faults
  output->avail_charge_faults = input->avail_charge_faults;
  // avail_discharge_faults
  output->avail_discharge_faults = input->avail_discharge_faults;
  return true;
}

canopen_inventus_interfaces__msg__VirtualBattery *
canopen_inventus_interfaces__msg__VirtualBattery__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  canopen_inventus_interfaces__msg__VirtualBattery * msg = (canopen_inventus_interfaces__msg__VirtualBattery *)allocator.allocate(sizeof(canopen_inventus_interfaces__msg__VirtualBattery), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(canopen_inventus_interfaces__msg__VirtualBattery));
  bool success = canopen_inventus_interfaces__msg__VirtualBattery__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
canopen_inventus_interfaces__msg__VirtualBattery__destroy(canopen_inventus_interfaces__msg__VirtualBattery * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    canopen_inventus_interfaces__msg__VirtualBattery__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__init(canopen_inventus_interfaces__msg__VirtualBattery__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  canopen_inventus_interfaces__msg__VirtualBattery * data = NULL;

  if (size) {
    data = (canopen_inventus_interfaces__msg__VirtualBattery *)allocator.zero_allocate(size, sizeof(canopen_inventus_interfaces__msg__VirtualBattery), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = canopen_inventus_interfaces__msg__VirtualBattery__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        canopen_inventus_interfaces__msg__VirtualBattery__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__fini(canopen_inventus_interfaces__msg__VirtualBattery__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      canopen_inventus_interfaces__msg__VirtualBattery__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

canopen_inventus_interfaces__msg__VirtualBattery__Sequence *
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  canopen_inventus_interfaces__msg__VirtualBattery__Sequence * array = (canopen_inventus_interfaces__msg__VirtualBattery__Sequence *)allocator.allocate(sizeof(canopen_inventus_interfaces__msg__VirtualBattery__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = canopen_inventus_interfaces__msg__VirtualBattery__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__destroy(canopen_inventus_interfaces__msg__VirtualBattery__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    canopen_inventus_interfaces__msg__VirtualBattery__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__are_equal(const canopen_inventus_interfaces__msg__VirtualBattery__Sequence * lhs, const canopen_inventus_interfaces__msg__VirtualBattery__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!canopen_inventus_interfaces__msg__VirtualBattery__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__copy(
  const canopen_inventus_interfaces__msg__VirtualBattery__Sequence * input,
  canopen_inventus_interfaces__msg__VirtualBattery__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(canopen_inventus_interfaces__msg__VirtualBattery);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    canopen_inventus_interfaces__msg__VirtualBattery * data =
      (canopen_inventus_interfaces__msg__VirtualBattery *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!canopen_inventus_interfaces__msg__VirtualBattery__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          canopen_inventus_interfaces__msg__VirtualBattery__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!canopen_inventus_interfaces__msg__VirtualBattery__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
