// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from canopen_inventus_interfaces:msg/VirtualBattery.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "canopen_inventus_interfaces/msg/virtual_battery.h"


#ifndef CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__FUNCTIONS_H_
#define CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "canopen_inventus_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "canopen_inventus_interfaces/msg/detail/virtual_battery__struct.h"

/// Initialize msg/VirtualBattery message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * canopen_inventus_interfaces__msg__VirtualBattery
 * )) before or use
 * canopen_inventus_interfaces__msg__VirtualBattery__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
bool
canopen_inventus_interfaces__msg__VirtualBattery__init(canopen_inventus_interfaces__msg__VirtualBattery * msg);

/// Finalize msg/VirtualBattery message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
void
canopen_inventus_interfaces__msg__VirtualBattery__fini(canopen_inventus_interfaces__msg__VirtualBattery * msg);

/// Create msg/VirtualBattery message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * canopen_inventus_interfaces__msg__VirtualBattery__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
canopen_inventus_interfaces__msg__VirtualBattery *
canopen_inventus_interfaces__msg__VirtualBattery__create(void);

/// Destroy msg/VirtualBattery message.
/**
 * It calls
 * canopen_inventus_interfaces__msg__VirtualBattery__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
void
canopen_inventus_interfaces__msg__VirtualBattery__destroy(canopen_inventus_interfaces__msg__VirtualBattery * msg);

/// Check for msg/VirtualBattery message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
bool
canopen_inventus_interfaces__msg__VirtualBattery__are_equal(const canopen_inventus_interfaces__msg__VirtualBattery * lhs, const canopen_inventus_interfaces__msg__VirtualBattery * rhs);

/// Copy a msg/VirtualBattery message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
bool
canopen_inventus_interfaces__msg__VirtualBattery__copy(
  const canopen_inventus_interfaces__msg__VirtualBattery * input,
  canopen_inventus_interfaces__msg__VirtualBattery * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
const rosidl_type_hash_t *
canopen_inventus_interfaces__msg__VirtualBattery__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
const rosidl_runtime_c__type_description__TypeDescription *
canopen_inventus_interfaces__msg__VirtualBattery__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
const rosidl_runtime_c__type_description__TypeSource *
canopen_inventus_interfaces__msg__VirtualBattery__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
const rosidl_runtime_c__type_description__TypeSource__Sequence *
canopen_inventus_interfaces__msg__VirtualBattery__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/VirtualBattery messages.
/**
 * It allocates the memory for the number of elements and calls
 * canopen_inventus_interfaces__msg__VirtualBattery__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
bool
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__init(canopen_inventus_interfaces__msg__VirtualBattery__Sequence * array, size_t size);

/// Finalize array of msg/VirtualBattery messages.
/**
 * It calls
 * canopen_inventus_interfaces__msg__VirtualBattery__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
void
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__fini(canopen_inventus_interfaces__msg__VirtualBattery__Sequence * array);

/// Create array of msg/VirtualBattery messages.
/**
 * It allocates the memory for the array and calls
 * canopen_inventus_interfaces__msg__VirtualBattery__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
canopen_inventus_interfaces__msg__VirtualBattery__Sequence *
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__create(size_t size);

/// Destroy array of msg/VirtualBattery messages.
/**
 * It calls
 * canopen_inventus_interfaces__msg__VirtualBattery__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
void
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__destroy(canopen_inventus_interfaces__msg__VirtualBattery__Sequence * array);

/// Check for msg/VirtualBattery message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
bool
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__are_equal(const canopen_inventus_interfaces__msg__VirtualBattery__Sequence * lhs, const canopen_inventus_interfaces__msg__VirtualBattery__Sequence * rhs);

/// Copy an array of msg/VirtualBattery messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_canopen_inventus_interfaces
bool
canopen_inventus_interfaces__msg__VirtualBattery__Sequence__copy(
  const canopen_inventus_interfaces__msg__VirtualBattery__Sequence * input,
  canopen_inventus_interfaces__msg__VirtualBattery__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__FUNCTIONS_H_
