// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from canopen_inventus_interfaces:msg/VirtualBattery.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "canopen_inventus_interfaces/msg/virtual_battery.hpp"


#ifndef CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__STRUCT_HPP_
#define CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__canopen_inventus_interfaces__msg__VirtualBattery __attribute__((deprecated))
#else
# define DEPRECATED__canopen_inventus_interfaces__msg__VirtualBattery __declspec(deprecated)
#endif

namespace canopen_inventus_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VirtualBattery_
{
  using Type = VirtualBattery_<ContainerAllocator>;

  explicit VirtualBattery_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->number_of_batteries = 0;
      this->soc = 0.0f;
      this->sum_capacity = 0.0f;
      this->remaining_runtime = 0.0f;
      this->remaining_chargetime = 0.0f;
      this->avg_voltage = 0.0f;
      this->sum_current = 0.0f;
      this->discharge_current_limit = 0.0f;
      this->charge_cutoff_current = 0.0f;
      this->fully_charged = 0;
      this->avg_temp = 0.0f;
      this->discharge_cutoff_voltage = 0.0f;
      this->charge_current_limit = 0.0f;
      this->max_voltage_allowed = 0.0f;
      this->avg_health = 0.0f;
      this->num_faulted_batteries = 0;
      this->num_active_batteries = 0;
      this->op_mode = 0;
      this->charge_fault = 0;
      this->discharge_fault = 0;
      this->regen_current_limit = 0.0f;
      this->min_cell_voltage = 0.0f;
      this->max_cell_voltage = 0.0f;
      this->cell_balance_status = 0;
      this->all_avg_voltage = 0.0f;
      this->all_soc = 0.0f;
      this->all_avg_temp = 0.0f;
      this->master_node_id = 0;
      this->avail_op_modes = 0;
      this->avail_charge_faults = 0;
      this->avail_discharge_faults = 0;
    }
  }

  explicit VirtualBattery_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->number_of_batteries = 0;
      this->soc = 0.0f;
      this->sum_capacity = 0.0f;
      this->remaining_runtime = 0.0f;
      this->remaining_chargetime = 0.0f;
      this->avg_voltage = 0.0f;
      this->sum_current = 0.0f;
      this->discharge_current_limit = 0.0f;
      this->charge_cutoff_current = 0.0f;
      this->fully_charged = 0;
      this->avg_temp = 0.0f;
      this->discharge_cutoff_voltage = 0.0f;
      this->charge_current_limit = 0.0f;
      this->max_voltage_allowed = 0.0f;
      this->avg_health = 0.0f;
      this->num_faulted_batteries = 0;
      this->num_active_batteries = 0;
      this->op_mode = 0;
      this->charge_fault = 0;
      this->discharge_fault = 0;
      this->regen_current_limit = 0.0f;
      this->min_cell_voltage = 0.0f;
      this->max_cell_voltage = 0.0f;
      this->cell_balance_status = 0;
      this->all_avg_voltage = 0.0f;
      this->all_soc = 0.0f;
      this->all_avg_temp = 0.0f;
      this->master_node_id = 0;
      this->avail_op_modes = 0;
      this->avail_charge_faults = 0;
      this->avail_discharge_faults = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _number_of_batteries_type =
    uint8_t;
  _number_of_batteries_type number_of_batteries;
  using _soc_type =
    float;
  _soc_type soc;
  using _sum_capacity_type =
    float;
  _sum_capacity_type sum_capacity;
  using _remaining_runtime_type =
    float;
  _remaining_runtime_type remaining_runtime;
  using _remaining_chargetime_type =
    float;
  _remaining_chargetime_type remaining_chargetime;
  using _avg_voltage_type =
    float;
  _avg_voltage_type avg_voltage;
  using _sum_current_type =
    float;
  _sum_current_type sum_current;
  using _discharge_current_limit_type =
    float;
  _discharge_current_limit_type discharge_current_limit;
  using _charge_cutoff_current_type =
    float;
  _charge_cutoff_current_type charge_cutoff_current;
  using _fully_charged_type =
    uint8_t;
  _fully_charged_type fully_charged;
  using _avg_temp_type =
    float;
  _avg_temp_type avg_temp;
  using _discharge_cutoff_voltage_type =
    float;
  _discharge_cutoff_voltage_type discharge_cutoff_voltage;
  using _charge_current_limit_type =
    float;
  _charge_current_limit_type charge_current_limit;
  using _max_voltage_allowed_type =
    float;
  _max_voltage_allowed_type max_voltage_allowed;
  using _avg_health_type =
    float;
  _avg_health_type avg_health;
  using _num_faulted_batteries_type =
    uint8_t;
  _num_faulted_batteries_type num_faulted_batteries;
  using _num_active_batteries_type =
    uint8_t;
  _num_active_batteries_type num_active_batteries;
  using _op_mode_type =
    uint8_t;
  _op_mode_type op_mode;
  using _charge_fault_type =
    uint16_t;
  _charge_fault_type charge_fault;
  using _discharge_fault_type =
    uint16_t;
  _discharge_fault_type discharge_fault;
  using _regen_current_limit_type =
    float;
  _regen_current_limit_type regen_current_limit;
  using _min_cell_voltage_type =
    float;
  _min_cell_voltage_type min_cell_voltage;
  using _max_cell_voltage_type =
    float;
  _max_cell_voltage_type max_cell_voltage;
  using _cell_balance_status_type =
    uint8_t;
  _cell_balance_status_type cell_balance_status;
  using _all_avg_voltage_type =
    float;
  _all_avg_voltage_type all_avg_voltage;
  using _all_soc_type =
    float;
  _all_soc_type all_soc;
  using _all_avg_temp_type =
    float;
  _all_avg_temp_type all_avg_temp;
  using _master_node_id_type =
    uint8_t;
  _master_node_id_type master_node_id;
  using _avail_op_modes_type =
    uint16_t;
  _avail_op_modes_type avail_op_modes;
  using _avail_charge_faults_type =
    uint16_t;
  _avail_charge_faults_type avail_charge_faults;
  using _avail_discharge_faults_type =
    uint16_t;
  _avail_discharge_faults_type avail_discharge_faults;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__number_of_batteries(
    const uint8_t & _arg)
  {
    this->number_of_batteries = _arg;
    return *this;
  }
  Type & set__soc(
    const float & _arg)
  {
    this->soc = _arg;
    return *this;
  }
  Type & set__sum_capacity(
    const float & _arg)
  {
    this->sum_capacity = _arg;
    return *this;
  }
  Type & set__remaining_runtime(
    const float & _arg)
  {
    this->remaining_runtime = _arg;
    return *this;
  }
  Type & set__remaining_chargetime(
    const float & _arg)
  {
    this->remaining_chargetime = _arg;
    return *this;
  }
  Type & set__avg_voltage(
    const float & _arg)
  {
    this->avg_voltage = _arg;
    return *this;
  }
  Type & set__sum_current(
    const float & _arg)
  {
    this->sum_current = _arg;
    return *this;
  }
  Type & set__discharge_current_limit(
    const float & _arg)
  {
    this->discharge_current_limit = _arg;
    return *this;
  }
  Type & set__charge_cutoff_current(
    const float & _arg)
  {
    this->charge_cutoff_current = _arg;
    return *this;
  }
  Type & set__fully_charged(
    const uint8_t & _arg)
  {
    this->fully_charged = _arg;
    return *this;
  }
  Type & set__avg_temp(
    const float & _arg)
  {
    this->avg_temp = _arg;
    return *this;
  }
  Type & set__discharge_cutoff_voltage(
    const float & _arg)
  {
    this->discharge_cutoff_voltage = _arg;
    return *this;
  }
  Type & set__charge_current_limit(
    const float & _arg)
  {
    this->charge_current_limit = _arg;
    return *this;
  }
  Type & set__max_voltage_allowed(
    const float & _arg)
  {
    this->max_voltage_allowed = _arg;
    return *this;
  }
  Type & set__avg_health(
    const float & _arg)
  {
    this->avg_health = _arg;
    return *this;
  }
  Type & set__num_faulted_batteries(
    const uint8_t & _arg)
  {
    this->num_faulted_batteries = _arg;
    return *this;
  }
  Type & set__num_active_batteries(
    const uint8_t & _arg)
  {
    this->num_active_batteries = _arg;
    return *this;
  }
  Type & set__op_mode(
    const uint8_t & _arg)
  {
    this->op_mode = _arg;
    return *this;
  }
  Type & set__charge_fault(
    const uint16_t & _arg)
  {
    this->charge_fault = _arg;
    return *this;
  }
  Type & set__discharge_fault(
    const uint16_t & _arg)
  {
    this->discharge_fault = _arg;
    return *this;
  }
  Type & set__regen_current_limit(
    const float & _arg)
  {
    this->regen_current_limit = _arg;
    return *this;
  }
  Type & set__min_cell_voltage(
    const float & _arg)
  {
    this->min_cell_voltage = _arg;
    return *this;
  }
  Type & set__max_cell_voltage(
    const float & _arg)
  {
    this->max_cell_voltage = _arg;
    return *this;
  }
  Type & set__cell_balance_status(
    const uint8_t & _arg)
  {
    this->cell_balance_status = _arg;
    return *this;
  }
  Type & set__all_avg_voltage(
    const float & _arg)
  {
    this->all_avg_voltage = _arg;
    return *this;
  }
  Type & set__all_soc(
    const float & _arg)
  {
    this->all_soc = _arg;
    return *this;
  }
  Type & set__all_avg_temp(
    const float & _arg)
  {
    this->all_avg_temp = _arg;
    return *this;
  }
  Type & set__master_node_id(
    const uint8_t & _arg)
  {
    this->master_node_id = _arg;
    return *this;
  }
  Type & set__avail_op_modes(
    const uint16_t & _arg)
  {
    this->avail_op_modes = _arg;
    return *this;
  }
  Type & set__avail_charge_faults(
    const uint16_t & _arg)
  {
    this->avail_charge_faults = _arg;
    return *this;
  }
  Type & set__avail_discharge_faults(
    const uint16_t & _arg)
  {
    this->avail_discharge_faults = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t OP_MODE_MODULE_BALANCING =
    1u;
  static constexpr uint16_t OP_MODE_SHIP =
    2u;
  static constexpr uint16_t OP_MODE_PRE_DISCHARGE =
    3u;
  static constexpr uint16_t OP_MODE_STANDBY =
    4u;
  static constexpr uint16_t OP_MODE_DISCHARGE =
    5u;
  static constexpr uint16_t OP_MODE_CHARGE =
    6u;
  static constexpr uint16_t OP_MODE_FAULT =
    7u;
  static constexpr uint16_t OP_MODE_PRE_CHARGE =
    8u;
  static constexpr uint16_t CHARGE_FAULT_HIGH_TEMP =
    1u;
  static constexpr uint16_t CHARGE_FAULT_LOW_TEMP =
    2u;
  static constexpr uint16_t CHARGE_FAULT_OVER_CURRENT =
    4u;
  static constexpr uint16_t CHARGE_FAULT_OVER_VOLTAGE =
    8u;
  static constexpr uint16_t CHARGE_FAULT_SHORT_CIRCUIT =
    16u;
  static constexpr uint16_t CHARGE_FAULT_OTHER =
    32u;
  static constexpr uint16_t CHARGE_FAULT_MOSFET_TEMP =
    64u;
  static constexpr uint16_t CHARGE_FAULT_SEVERE_UNDER_VOLTAGE =
    128u;
  static constexpr uint16_t CHARGE_FAULT_COM_AFE_FAILED =
    256u;
  static constexpr uint16_t CHARGE_FAULT_HW_SECOND_OVP =
    512u;
  static constexpr uint16_t CHARGE_FAULT_RESERVED =
    1024u;
  static constexpr uint16_t CHARGE_FAULT_PRECHARGE_FAILED =
    2048u;
  static constexpr uint16_t CHARGE_FAULT_PACK_PARALLEL_ERROR =
    4096u;
  static constexpr uint16_t CHARGE_FAULT_SIGNAL_ERROR =
    8192u;
  static constexpr uint16_t CHARGE_FAULT_PREDISCHARGE_FAILED =
    16384u;
  static constexpr uint16_t CHARGE_FAULT_INTERNAL_COMM_FAILURE =
    32768u;
  static constexpr uint16_t DISCHARGE_FAULT_HIGH_TEMP =
    1u;
  static constexpr uint16_t DISCHARGE_FAULT_LOW_TEMP =
    2u;
  static constexpr uint16_t DISCHARGE_FAULT_OVER_CURRENT =
    4u;
  static constexpr uint16_t DISCHARGE_FAULT_UNDER_VOLTAGE =
    8u;
  static constexpr uint16_t DISCHARGE_FAULT_SHORT_CIRCUIT =
    16u;
  static constexpr uint16_t DISCHARGE_FAULT_OTHER =
    32u;
  static constexpr uint16_t DISCHARGE_FAULT_MOSFET_TEMP =
    64u;
  static constexpr uint16_t DISCHARGE_FAULT_SEVERE_UNDER_VOLTAGE =
    128u;
  static constexpr uint16_t DISCHARGE_FAULT_COM_AFE_FAILED =
    256u;
  static constexpr uint16_t DISCHARGE_FAULT_HW_SECOND_OVP =
    512u;
  static constexpr uint16_t DISCHARGE_FAULT_RESERVED =
    1024u;
  static constexpr uint16_t DISCHARGE_FAULT_RESERVED_2 =
    2048u;
  static constexpr uint16_t DISCHARGE_FAULT_PACK_PARALLEL_ERROR =
    4096u;
  static constexpr uint16_t DISCHARGE_FAULT_SIGNAL_ERROR =
    8192u;
  static constexpr uint16_t DISCHARGE_FAULT_PREDISCHARGE_FAILED =
    16384u;
  static constexpr uint16_t DISCHARGE_FAULT_INTERNAL_COMM_FAILURE =
    32768u;

  // pointer types
  using RawPtr =
    canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator> *;
  using ConstRawPtr =
    const canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__canopen_inventus_interfaces__msg__VirtualBattery
    std::shared_ptr<canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__canopen_inventus_interfaces__msg__VirtualBattery
    std::shared_ptr<canopen_inventus_interfaces::msg::VirtualBattery_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VirtualBattery_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->number_of_batteries != other.number_of_batteries) {
      return false;
    }
    if (this->soc != other.soc) {
      return false;
    }
    if (this->sum_capacity != other.sum_capacity) {
      return false;
    }
    if (this->remaining_runtime != other.remaining_runtime) {
      return false;
    }
    if (this->remaining_chargetime != other.remaining_chargetime) {
      return false;
    }
    if (this->avg_voltage != other.avg_voltage) {
      return false;
    }
    if (this->sum_current != other.sum_current) {
      return false;
    }
    if (this->discharge_current_limit != other.discharge_current_limit) {
      return false;
    }
    if (this->charge_cutoff_current != other.charge_cutoff_current) {
      return false;
    }
    if (this->fully_charged != other.fully_charged) {
      return false;
    }
    if (this->avg_temp != other.avg_temp) {
      return false;
    }
    if (this->discharge_cutoff_voltage != other.discharge_cutoff_voltage) {
      return false;
    }
    if (this->charge_current_limit != other.charge_current_limit) {
      return false;
    }
    if (this->max_voltage_allowed != other.max_voltage_allowed) {
      return false;
    }
    if (this->avg_health != other.avg_health) {
      return false;
    }
    if (this->num_faulted_batteries != other.num_faulted_batteries) {
      return false;
    }
    if (this->num_active_batteries != other.num_active_batteries) {
      return false;
    }
    if (this->op_mode != other.op_mode) {
      return false;
    }
    if (this->charge_fault != other.charge_fault) {
      return false;
    }
    if (this->discharge_fault != other.discharge_fault) {
      return false;
    }
    if (this->regen_current_limit != other.regen_current_limit) {
      return false;
    }
    if (this->min_cell_voltage != other.min_cell_voltage) {
      return false;
    }
    if (this->max_cell_voltage != other.max_cell_voltage) {
      return false;
    }
    if (this->cell_balance_status != other.cell_balance_status) {
      return false;
    }
    if (this->all_avg_voltage != other.all_avg_voltage) {
      return false;
    }
    if (this->all_soc != other.all_soc) {
      return false;
    }
    if (this->all_avg_temp != other.all_avg_temp) {
      return false;
    }
    if (this->master_node_id != other.master_node_id) {
      return false;
    }
    if (this->avail_op_modes != other.avail_op_modes) {
      return false;
    }
    if (this->avail_charge_faults != other.avail_charge_faults) {
      return false;
    }
    if (this->avail_discharge_faults != other.avail_discharge_faults) {
      return false;
    }
    return true;
  }
  bool operator!=(const VirtualBattery_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VirtualBattery_

// alias to use template instance with default allocator
using VirtualBattery =
  canopen_inventus_interfaces::msg::VirtualBattery_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::OP_MODE_MODULE_BALANCING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::OP_MODE_SHIP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::OP_MODE_PRE_DISCHARGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::OP_MODE_STANDBY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::OP_MODE_DISCHARGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::OP_MODE_CHARGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::OP_MODE_FAULT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::OP_MODE_PRE_CHARGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_HIGH_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_LOW_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_OVER_CURRENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_OVER_VOLTAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_SHORT_CIRCUIT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_OTHER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_MOSFET_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_SEVERE_UNDER_VOLTAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_COM_AFE_FAILED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_HW_SECOND_OVP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_RESERVED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_PRECHARGE_FAILED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_PACK_PARALLEL_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_SIGNAL_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_PREDISCHARGE_FAILED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::CHARGE_FAULT_INTERNAL_COMM_FAILURE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_HIGH_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_LOW_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_OVER_CURRENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_UNDER_VOLTAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_SHORT_CIRCUIT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_OTHER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_MOSFET_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_SEVERE_UNDER_VOLTAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_COM_AFE_FAILED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_HW_SECOND_OVP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_RESERVED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_RESERVED_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_PACK_PARALLEL_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_SIGNAL_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_PREDISCHARGE_FAILED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t VirtualBattery_<ContainerAllocator>::DISCHARGE_FAULT_INTERNAL_COMM_FAILURE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace canopen_inventus_interfaces

#endif  // CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__STRUCT_HPP_
