// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from canopen_inventus_interfaces:msg/Status.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "canopen_inventus_interfaces/msg/status.hpp"


#ifndef CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__STATUS__STRUCT_HPP_
#define CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__canopen_inventus_interfaces__msg__Status __attribute__((deprecated))
#else
# define DEPRECATED__canopen_inventus_interfaces__msg__Status __declspec(deprecated)
#endif

namespace canopen_inventus_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Status_
{
  using Type = Status_<ContainerAllocator>;

  explicit Status_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->hardware_version = "";
      this->software_version = "";
      this->firmware_version = "";
      this->serial_number = "";
      this->current = 0.0f;
      this->voltage = 0.0f;
      this->temperature = 0.0f;
      this->min_cell_temperature = 0.0f;
      this->max_cell_temperature = 0.0f;
      this->state_of_charge = 0.0f;
      this->full_charge_capacity = 0.0f;
      this->design_capacity = 0.0f;
      this->remaining_capacity = 0.0f;
      this->op_mode = 0;
      this->charge_fault = 0;
      this->discharge_fault = 0;
    }
  }

  explicit Status_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    hardware_version(_alloc),
    software_version(_alloc),
    firmware_version(_alloc),
    serial_number(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->hardware_version = "";
      this->software_version = "";
      this->firmware_version = "";
      this->serial_number = "";
      this->current = 0.0f;
      this->voltage = 0.0f;
      this->temperature = 0.0f;
      this->min_cell_temperature = 0.0f;
      this->max_cell_temperature = 0.0f;
      this->state_of_charge = 0.0f;
      this->full_charge_capacity = 0.0f;
      this->design_capacity = 0.0f;
      this->remaining_capacity = 0.0f;
      this->op_mode = 0;
      this->charge_fault = 0;
      this->discharge_fault = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _hardware_version_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _hardware_version_type hardware_version;
  using _software_version_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _software_version_type software_version;
  using _firmware_version_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _firmware_version_type firmware_version;
  using _serial_number_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _serial_number_type serial_number;
  using _current_type =
    float;
  _current_type current;
  using _voltage_type =
    float;
  _voltage_type voltage;
  using _temperature_type =
    float;
  _temperature_type temperature;
  using _min_cell_temperature_type =
    float;
  _min_cell_temperature_type min_cell_temperature;
  using _max_cell_temperature_type =
    float;
  _max_cell_temperature_type max_cell_temperature;
  using _state_of_charge_type =
    float;
  _state_of_charge_type state_of_charge;
  using _full_charge_capacity_type =
    float;
  _full_charge_capacity_type full_charge_capacity;
  using _design_capacity_type =
    float;
  _design_capacity_type design_capacity;
  using _remaining_capacity_type =
    float;
  _remaining_capacity_type remaining_capacity;
  using _cell_voltage_type =
    std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>>;
  _cell_voltage_type cell_voltage;
  using _op_mode_type =
    uint16_t;
  _op_mode_type op_mode;
  using _charge_fault_type =
    uint16_t;
  _charge_fault_type charge_fault;
  using _discharge_fault_type =
    uint16_t;
  _discharge_fault_type discharge_fault;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__hardware_version(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->hardware_version = _arg;
    return *this;
  }
  Type & set__software_version(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->software_version = _arg;
    return *this;
  }
  Type & set__firmware_version(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->firmware_version = _arg;
    return *this;
  }
  Type & set__serial_number(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->serial_number = _arg;
    return *this;
  }
  Type & set__current(
    const float & _arg)
  {
    this->current = _arg;
    return *this;
  }
  Type & set__voltage(
    const float & _arg)
  {
    this->voltage = _arg;
    return *this;
  }
  Type & set__temperature(
    const float & _arg)
  {
    this->temperature = _arg;
    return *this;
  }
  Type & set__min_cell_temperature(
    const float & _arg)
  {
    this->min_cell_temperature = _arg;
    return *this;
  }
  Type & set__max_cell_temperature(
    const float & _arg)
  {
    this->max_cell_temperature = _arg;
    return *this;
  }
  Type & set__state_of_charge(
    const float & _arg)
  {
    this->state_of_charge = _arg;
    return *this;
  }
  Type & set__full_charge_capacity(
    const float & _arg)
  {
    this->full_charge_capacity = _arg;
    return *this;
  }
  Type & set__design_capacity(
    const float & _arg)
  {
    this->design_capacity = _arg;
    return *this;
  }
  Type & set__remaining_capacity(
    const float & _arg)
  {
    this->remaining_capacity = _arg;
    return *this;
  }
  Type & set__cell_voltage(
    const std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>> & _arg)
  {
    this->cell_voltage = _arg;
    return *this;
  }
  Type & set__op_mode(
    const uint16_t & _arg)
  {
    this->op_mode = _arg;
    return *this;
  }
  Type & set__charge_fault(
    const uint16_t & _arg)
  {
    this->charge_fault = _arg;
    return *this;
  }
  Type & set__discharge_fault(
    const uint16_t & _arg)
  {
    this->discharge_fault = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t OP_MODE_MODULE_BALANCING =
    1u;
  static constexpr uint16_t OP_MODE_SHIP =
    2u;
  static constexpr uint16_t OP_MODE_PRE_DISCHARGE =
    3u;
  static constexpr uint16_t OP_MODE_STANDBY =
    4u;
  static constexpr uint16_t OP_MODE_DISCHARGE =
    5u;
  static constexpr uint16_t OP_MODE_CHARGE =
    6u;
  static constexpr uint16_t OP_MODE_FAULT =
    7u;
  static constexpr uint16_t OP_MODE_PRE_CHARGE =
    8u;
  static constexpr uint16_t CHARGE_FAULT_HIGH_TEMP =
    1u;
  static constexpr uint16_t CHARGE_FAULT_LOW_TEMP =
    2u;
  static constexpr uint16_t CHARGE_FAULT_OVER_CURRENT =
    4u;
  static constexpr uint16_t CHARGE_FAULT_OVER_VOLTAGE =
    8u;
  static constexpr uint16_t CHARGE_FAULT_SHORT_CIRCUIT =
    16u;
  static constexpr uint16_t CHARGE_FAULT_OTHER =
    32u;
  static constexpr uint16_t CHARGE_FAULT_MOSFET_TEMP =
    64u;
  static constexpr uint16_t CHARGE_FAULT_SEVERE_UNDER_VOLTAGE =
    128u;
  static constexpr uint16_t CHARGE_FAULT_COM_AFE_FAILED =
    256u;
  static constexpr uint16_t CHARGE_FAULT_HW_SECOND_OVP =
    512u;
  static constexpr uint16_t CHARGE_FAULT_RESERVED =
    1024u;
  static constexpr uint16_t CHARGE_FAULT_PRECHARGE_FAILED =
    2048u;
  static constexpr uint16_t CHARGE_FAULT_PACK_PARALLEL_ERROR =
    4096u;
  static constexpr uint16_t CHARGE_FAULT_SIGNAL_ERROR =
    8192u;
  static constexpr uint16_t CHARGE_FAULT_PREDISCHARGE_FAILED =
    16384u;
  static constexpr uint16_t CHARGE_FAULT_INTERNAL_COMM_FAILURE =
    32768u;
  static constexpr uint16_t DISCHARGE_FAULT_HIGH_TEMP =
    1u;
  static constexpr uint16_t DISCHARGE_FAULT_LOW_TEMP =
    2u;
  static constexpr uint16_t DISCHARGE_FAULT_OVER_CURRENT =
    4u;
  static constexpr uint16_t DISCHARGE_FAULT_UNDER_VOLTAGE =
    8u;
  static constexpr uint16_t DISCHARGE_FAULT_SHORT_CIRCUIT =
    16u;
  static constexpr uint16_t DISCHARGE_FAULT_OTHER =
    32u;
  static constexpr uint16_t DISCHARGE_FAULT_MOSFET_TEMP =
    64u;
  static constexpr uint16_t DISCHARGE_FAULT_SEVERE_UNDER_VOLTAGE =
    128u;
  static constexpr uint16_t DISCHARGE_FAULT_COM_AFE_FAILED =
    256u;
  static constexpr uint16_t DISCHARGE_FAULT_HW_SECOND_OVP =
    512u;
  static constexpr uint16_t DISCHARGE_FAULT_RESERVED =
    1024u;
  static constexpr uint16_t DISCHARGE_FAULT_RESERVED_2 =
    2048u;
  static constexpr uint16_t DISCHARGE_FAULT_PACK_PARALLEL_ERROR =
    4096u;
  static constexpr uint16_t DISCHARGE_FAULT_SIGNAL_ERROR =
    8192u;
  static constexpr uint16_t DISCHARGE_FAULT_PREDISCHARGE_FAILED =
    16384u;
  static constexpr uint16_t DISCHARGE_FAULT_INTERNAL_COMM_FAILURE =
    32768u;

  // pointer types
  using RawPtr =
    canopen_inventus_interfaces::msg::Status_<ContainerAllocator> *;
  using ConstRawPtr =
    const canopen_inventus_interfaces::msg::Status_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<canopen_inventus_interfaces::msg::Status_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<canopen_inventus_interfaces::msg::Status_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      canopen_inventus_interfaces::msg::Status_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<canopen_inventus_interfaces::msg::Status_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      canopen_inventus_interfaces::msg::Status_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<canopen_inventus_interfaces::msg::Status_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<canopen_inventus_interfaces::msg::Status_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<canopen_inventus_interfaces::msg::Status_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__canopen_inventus_interfaces__msg__Status
    std::shared_ptr<canopen_inventus_interfaces::msg::Status_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__canopen_inventus_interfaces__msg__Status
    std::shared_ptr<canopen_inventus_interfaces::msg::Status_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Status_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->hardware_version != other.hardware_version) {
      return false;
    }
    if (this->software_version != other.software_version) {
      return false;
    }
    if (this->firmware_version != other.firmware_version) {
      return false;
    }
    if (this->serial_number != other.serial_number) {
      return false;
    }
    if (this->current != other.current) {
      return false;
    }
    if (this->voltage != other.voltage) {
      return false;
    }
    if (this->temperature != other.temperature) {
      return false;
    }
    if (this->min_cell_temperature != other.min_cell_temperature) {
      return false;
    }
    if (this->max_cell_temperature != other.max_cell_temperature) {
      return false;
    }
    if (this->state_of_charge != other.state_of_charge) {
      return false;
    }
    if (this->full_charge_capacity != other.full_charge_capacity) {
      return false;
    }
    if (this->design_capacity != other.design_capacity) {
      return false;
    }
    if (this->remaining_capacity != other.remaining_capacity) {
      return false;
    }
    if (this->cell_voltage != other.cell_voltage) {
      return false;
    }
    if (this->op_mode != other.op_mode) {
      return false;
    }
    if (this->charge_fault != other.charge_fault) {
      return false;
    }
    if (this->discharge_fault != other.discharge_fault) {
      return false;
    }
    return true;
  }
  bool operator!=(const Status_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Status_

// alias to use template instance with default allocator
using Status =
  canopen_inventus_interfaces::msg::Status_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::OP_MODE_MODULE_BALANCING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::OP_MODE_SHIP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::OP_MODE_PRE_DISCHARGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::OP_MODE_STANDBY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::OP_MODE_DISCHARGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::OP_MODE_CHARGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::OP_MODE_FAULT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::OP_MODE_PRE_CHARGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_HIGH_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_LOW_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_OVER_CURRENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_OVER_VOLTAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_SHORT_CIRCUIT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_OTHER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_MOSFET_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_SEVERE_UNDER_VOLTAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_COM_AFE_FAILED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_HW_SECOND_OVP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_RESERVED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_PRECHARGE_FAILED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_PACK_PARALLEL_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_SIGNAL_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_PREDISCHARGE_FAILED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::CHARGE_FAULT_INTERNAL_COMM_FAILURE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_HIGH_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_LOW_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_OVER_CURRENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_UNDER_VOLTAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_SHORT_CIRCUIT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_OTHER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_MOSFET_TEMP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_SEVERE_UNDER_VOLTAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_COM_AFE_FAILED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_HW_SECOND_OVP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_RESERVED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_RESERVED_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_PACK_PARALLEL_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_SIGNAL_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_PREDISCHARGE_FAILED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Status_<ContainerAllocator>::DISCHARGE_FAULT_INTERNAL_COMM_FAILURE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace canopen_inventus_interfaces

#endif  // CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__STATUS__STRUCT_HPP_
