// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from canopen_inventus_interfaces:msg/Status.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "canopen_inventus_interfaces/msg/status.hpp"


#ifndef CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__STATUS__TRAITS_HPP_
#define CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "canopen_inventus_interfaces/msg/detail/status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace canopen_inventus_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const Status & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: hardware_version
  {
    out << "hardware_version: ";
    rosidl_generator_traits::value_to_yaml(msg.hardware_version, out);
    out << ", ";
  }

  // member: software_version
  {
    out << "software_version: ";
    rosidl_generator_traits::value_to_yaml(msg.software_version, out);
    out << ", ";
  }

  // member: firmware_version
  {
    out << "firmware_version: ";
    rosidl_generator_traits::value_to_yaml(msg.firmware_version, out);
    out << ", ";
  }

  // member: serial_number
  {
    out << "serial_number: ";
    rosidl_generator_traits::value_to_yaml(msg.serial_number, out);
    out << ", ";
  }

  // member: current
  {
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << ", ";
  }

  // member: voltage
  {
    out << "voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.voltage, out);
    out << ", ";
  }

  // member: temperature
  {
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
    out << ", ";
  }

  // member: min_cell_temperature
  {
    out << "min_cell_temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.min_cell_temperature, out);
    out << ", ";
  }

  // member: max_cell_temperature
  {
    out << "max_cell_temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.max_cell_temperature, out);
    out << ", ";
  }

  // member: state_of_charge
  {
    out << "state_of_charge: ";
    rosidl_generator_traits::value_to_yaml(msg.state_of_charge, out);
    out << ", ";
  }

  // member: full_charge_capacity
  {
    out << "full_charge_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.full_charge_capacity, out);
    out << ", ";
  }

  // member: design_capacity
  {
    out << "design_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.design_capacity, out);
    out << ", ";
  }

  // member: remaining_capacity
  {
    out << "remaining_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.remaining_capacity, out);
    out << ", ";
  }

  // member: cell_voltage
  {
    if (msg.cell_voltage.size() == 0) {
      out << "cell_voltage: []";
    } else {
      out << "cell_voltage: [";
      size_t pending_items = msg.cell_voltage.size();
      for (auto item : msg.cell_voltage) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: op_mode
  {
    out << "op_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.op_mode, out);
    out << ", ";
  }

  // member: charge_fault
  {
    out << "charge_fault: ";
    rosidl_generator_traits::value_to_yaml(msg.charge_fault, out);
    out << ", ";
  }

  // member: discharge_fault
  {
    out << "discharge_fault: ";
    rosidl_generator_traits::value_to_yaml(msg.discharge_fault, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Status & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: hardware_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hardware_version: ";
    rosidl_generator_traits::value_to_yaml(msg.hardware_version, out);
    out << "\n";
  }

  // member: software_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "software_version: ";
    rosidl_generator_traits::value_to_yaml(msg.software_version, out);
    out << "\n";
  }

  // member: firmware_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "firmware_version: ";
    rosidl_generator_traits::value_to_yaml(msg.firmware_version, out);
    out << "\n";
  }

  // member: serial_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "serial_number: ";
    rosidl_generator_traits::value_to_yaml(msg.serial_number, out);
    out << "\n";
  }

  // member: current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << "\n";
  }

  // member: voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.voltage, out);
    out << "\n";
  }

  // member: temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
    out << "\n";
  }

  // member: min_cell_temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_cell_temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.min_cell_temperature, out);
    out << "\n";
  }

  // member: max_cell_temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_cell_temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.max_cell_temperature, out);
    out << "\n";
  }

  // member: state_of_charge
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "state_of_charge: ";
    rosidl_generator_traits::value_to_yaml(msg.state_of_charge, out);
    out << "\n";
  }

  // member: full_charge_capacity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "full_charge_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.full_charge_capacity, out);
    out << "\n";
  }

  // member: design_capacity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "design_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.design_capacity, out);
    out << "\n";
  }

  // member: remaining_capacity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "remaining_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.remaining_capacity, out);
    out << "\n";
  }

  // member: cell_voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.cell_voltage.size() == 0) {
      out << "cell_voltage: []\n";
    } else {
      out << "cell_voltage:\n";
      for (auto item : msg.cell_voltage) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: op_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "op_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.op_mode, out);
    out << "\n";
  }

  // member: charge_fault
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "charge_fault: ";
    rosidl_generator_traits::value_to_yaml(msg.charge_fault, out);
    out << "\n";
  }

  // member: discharge_fault
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "discharge_fault: ";
    rosidl_generator_traits::value_to_yaml(msg.discharge_fault, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Status & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace canopen_inventus_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use canopen_inventus_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const canopen_inventus_interfaces::msg::Status & msg,
  std::ostream & out, size_t indentation = 0)
{
  canopen_inventus_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use canopen_inventus_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const canopen_inventus_interfaces::msg::Status & msg)
{
  return canopen_inventus_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<canopen_inventus_interfaces::msg::Status>()
{
  return "canopen_inventus_interfaces::msg::Status";
}

template<>
inline const char * name<canopen_inventus_interfaces::msg::Status>()
{
  return "canopen_inventus_interfaces/msg/Status";
}

template<>
struct has_fixed_size<canopen_inventus_interfaces::msg::Status>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<canopen_inventus_interfaces::msg::Status>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<canopen_inventus_interfaces::msg::Status>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__STATUS__TRAITS_HPP_
