﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from canopen_inventus_interfaces:msg/VirtualBattery.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "canopen_inventus_interfaces/msg/virtual_battery.h"


#ifndef CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__STRUCT_H_
#define CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'OP_MODE_MODULE_BALANCING'.
/**
  * Operational Model Enum
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__OP_MODE_MODULE_BALANCING = 1
};

/// Constant 'OP_MODE_SHIP'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__OP_MODE_SHIP = 2
};

/// Constant 'OP_MODE_PRE_DISCHARGE'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__OP_MODE_PRE_DISCHARGE = 3
};

/// Constant 'OP_MODE_STANDBY'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__OP_MODE_STANDBY = 4
};

/// Constant 'OP_MODE_DISCHARGE'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__OP_MODE_DISCHARGE = 5
};

/// Constant 'OP_MODE_CHARGE'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__OP_MODE_CHARGE = 6
};

/// Constant 'OP_MODE_FAULT'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__OP_MODE_FAULT = 7
};

/// Constant 'OP_MODE_PRE_CHARGE'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__OP_MODE_PRE_CHARGE = 8
};

/// Constant 'CHARGE_FAULT_HIGH_TEMP'.
/**
  * Charge Fault Bit Masks
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_HIGH_TEMP = 1
};

/// Constant 'CHARGE_FAULT_LOW_TEMP'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_LOW_TEMP = 2
};

/// Constant 'CHARGE_FAULT_OVER_CURRENT'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_OVER_CURRENT = 4
};

/// Constant 'CHARGE_FAULT_OVER_VOLTAGE'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_OVER_VOLTAGE = 8
};

/// Constant 'CHARGE_FAULT_SHORT_CIRCUIT'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_SHORT_CIRCUIT = 16
};

/// Constant 'CHARGE_FAULT_OTHER'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_OTHER = 32
};

/// Constant 'CHARGE_FAULT_MOSFET_TEMP'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_MOSFET_TEMP = 64
};

/// Constant 'CHARGE_FAULT_SEVERE_UNDER_VOLTAGE'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_SEVERE_UNDER_VOLTAGE = 128
};

/// Constant 'CHARGE_FAULT_COM_AFE_FAILED'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_COM_AFE_FAILED = 256
};

/// Constant 'CHARGE_FAULT_HW_SECOND_OVP'.
/**
  * Marked as reserved as of SW guide 1.4
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_HW_SECOND_OVP = 512
};

/// Constant 'CHARGE_FAULT_RESERVED'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_RESERVED = 1024
};

/// Constant 'CHARGE_FAULT_PRECHARGE_FAILED'.
/**
  * Marked as reserved as of SW guide 1.4
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_PRECHARGE_FAILED = 2048
};

/// Constant 'CHARGE_FAULT_PACK_PARALLEL_ERROR'.
/**
  * Marked as reserved as of SW guide 1.4
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_PACK_PARALLEL_ERROR = 4096
};

/// Constant 'CHARGE_FAULT_SIGNAL_ERROR'.
/**
  * Marked as reserved as of SW guide 1.4
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_SIGNAL_ERROR = 8192
};

/// Constant 'CHARGE_FAULT_PREDISCHARGE_FAILED'.
/**
  * Marked as reserved as of SW guide 1.4
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_PREDISCHARGE_FAILED = 16384
};

/// Constant 'CHARGE_FAULT_INTERNAL_COMM_FAILURE'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__CHARGE_FAULT_INTERNAL_COMM_FAILURE = 32768
};

/// Constant 'DISCHARGE_FAULT_HIGH_TEMP'.
/**
  * Discharge Fault Bit Masks
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_HIGH_TEMP = 1
};

/// Constant 'DISCHARGE_FAULT_LOW_TEMP'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_LOW_TEMP = 2
};

/// Constant 'DISCHARGE_FAULT_OVER_CURRENT'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_OVER_CURRENT = 4
};

/// Constant 'DISCHARGE_FAULT_UNDER_VOLTAGE'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_UNDER_VOLTAGE = 8
};

/// Constant 'DISCHARGE_FAULT_SHORT_CIRCUIT'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_SHORT_CIRCUIT = 16
};

/// Constant 'DISCHARGE_FAULT_OTHER'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_OTHER = 32
};

/// Constant 'DISCHARGE_FAULT_MOSFET_TEMP'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_MOSFET_TEMP = 64
};

/// Constant 'DISCHARGE_FAULT_SEVERE_UNDER_VOLTAGE'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_SEVERE_UNDER_VOLTAGE = 128
};

/// Constant 'DISCHARGE_FAULT_COM_AFE_FAILED'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_COM_AFE_FAILED = 256
};

/// Constant 'DISCHARGE_FAULT_HW_SECOND_OVP'.
/**
  * Marked as reserved as of SW guide 1.4
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_HW_SECOND_OVP = 512
};

/// Constant 'DISCHARGE_FAULT_RESERVED'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_RESERVED = 1024
};

/// Constant 'DISCHARGE_FAULT_RESERVED_2'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_RESERVED_2 = 2048
};

/// Constant 'DISCHARGE_FAULT_PACK_PARALLEL_ERROR'.
/**
  * Marked as reserved as of SW guide 1.4
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_PACK_PARALLEL_ERROR = 4096
};

/// Constant 'DISCHARGE_FAULT_SIGNAL_ERROR'.
/**
  * Marked as reserved as of SW guide 1.4
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_SIGNAL_ERROR = 8192
};

/// Constant 'DISCHARGE_FAULT_PREDISCHARGE_FAILED'.
/**
  * Marked as reserved as of SW guide 1.4
 */
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_PREDISCHARGE_FAILED = 16384
};

/// Constant 'DISCHARGE_FAULT_INTERNAL_COMM_FAILURE'.
enum
{
  canopen_inventus_interfaces__msg__VirtualBattery__DISCHARGE_FAULT_INTERNAL_COMM_FAILURE = 32768
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/VirtualBattery in the package canopen_inventus_interfaces.
/**
  * Inventus Virtual Battery
  * All PDO produced by the batteries refer to the multi-battery system.
  * Therefore, this message must only be published by the master node.
 */
typedef struct canopen_inventus_interfaces__msg__VirtualBattery
{
  /// Header
  std_msgs__msg__Header header;
  /// TPDO1
  /// Number of batteries in parallel.
  uint8_t number_of_batteries;
  /// Average SOC of all non-faulted batteries.
  float soc;
  /// Sum of the remaining capacity of all non-faulted batteries.
  float sum_capacity;
  /// Remaining run time of all non-faulted batteries.
  float remaining_runtime;
  /// Remaining time to full charge of all non-faulted batteries.
  float remaining_chargetime;
  /// TPDO2
  /// Average voltage of all non-faulted battery packs.
  float avg_voltage;
  /// Combined current value of all non-faulted battery packs.
  /// Charge/regen current (+), Discharge current (-).
  float sum_current;
  /// Combined discharge current limit of all non-faulted battery packs.
  float discharge_current_limit;
  /// Combined taper current of all non-faulted battery packs when nearing charge cutoff voltage.
  float charge_cutoff_current;
  /// 0 – All non-faulted battery packs not at charge termination voltage.
  /// 1 – All non-faulted battery packs at charge termination voltage.
  uint8_t fully_charged;
  /// TPDO3
  /// Average temperature of all non-faulted battery packs.
  float avg_temp;
  /// Voltage at which a battery pack will open FETs to stop discharging.
  float discharge_cutoff_voltage;
  /// Combined charge current limit of all non-faulted battery packs.
  float charge_current_limit;
  /// Maximum allowed charging voltage.
  float max_voltage_allowed;
  /// TPDO4
  /// Average state of health of all non-faulted battery packs.
  float avg_health;
  /// Number of batteries in the system that are faulted.
  uint8_t num_faulted_batteries;
  /// Number of batteries in the system that are not faulted.
  uint8_t num_active_batteries;
  /// Operational mode of all non-faulted battery packs.
  /// This value will only show “fault mode” if all battery packs in the system are faulted.
  uint8_t op_mode;
  /// Combined charge fault of all battery packs.
  uint16_t charge_fault;
  /// Combined discharge fault of all battery packs.
  uint16_t discharge_fault;
  /// TPD05
  /// Combined regen current limit of all non-faulted battery packs.
  float regen_current_limit;
  /// Min cell voltage of all non-faulted battery packs.
  float min_cell_voltage;
  /// Max cell voltage of all non-faulted battery packs.
  float max_cell_voltage;
  /// Cell balance status of all battery packs.
  /// Each bit will represent one battery, nth bit will represent nth battery pack.
  /// Bit = 1 means cell balance of this battery pack is enabling.
  /// Bit = 0 means cell balance of this battery pack is Idle.
  uint8_t cell_balance_status;
  /// TPD06
  /// Average pack voltage of all battery packs
  float all_avg_voltage;
  /// Average SOC value of all battery packs
  float all_soc;
  /// Average temperature of all battery packs
  float all_avg_temp;
  /// The node ID of master pack
  uint8_t master_node_id;
  uint16_t avail_op_modes;
  uint16_t avail_charge_faults;
  uint16_t avail_discharge_faults;
} canopen_inventus_interfaces__msg__VirtualBattery;

// Struct for a sequence of canopen_inventus_interfaces__msg__VirtualBattery.
typedef struct canopen_inventus_interfaces__msg__VirtualBattery__Sequence
{
  canopen_inventus_interfaces__msg__VirtualBattery * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} canopen_inventus_interfaces__msg__VirtualBattery__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__STRUCT_H_
