// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from canopen_inventus_interfaces:msg/VirtualBattery.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "canopen_inventus_interfaces/msg/virtual_battery.hpp"


#ifndef CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__TRAITS_HPP_
#define CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "canopen_inventus_interfaces/msg/detail/virtual_battery__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace canopen_inventus_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const VirtualBattery & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: number_of_batteries
  {
    out << "number_of_batteries: ";
    rosidl_generator_traits::value_to_yaml(msg.number_of_batteries, out);
    out << ", ";
  }

  // member: soc
  {
    out << "soc: ";
    rosidl_generator_traits::value_to_yaml(msg.soc, out);
    out << ", ";
  }

  // member: sum_capacity
  {
    out << "sum_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.sum_capacity, out);
    out << ", ";
  }

  // member: remaining_runtime
  {
    out << "remaining_runtime: ";
    rosidl_generator_traits::value_to_yaml(msg.remaining_runtime, out);
    out << ", ";
  }

  // member: remaining_chargetime
  {
    out << "remaining_chargetime: ";
    rosidl_generator_traits::value_to_yaml(msg.remaining_chargetime, out);
    out << ", ";
  }

  // member: avg_voltage
  {
    out << "avg_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.avg_voltage, out);
    out << ", ";
  }

  // member: sum_current
  {
    out << "sum_current: ";
    rosidl_generator_traits::value_to_yaml(msg.sum_current, out);
    out << ", ";
  }

  // member: discharge_current_limit
  {
    out << "discharge_current_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.discharge_current_limit, out);
    out << ", ";
  }

  // member: charge_cutoff_current
  {
    out << "charge_cutoff_current: ";
    rosidl_generator_traits::value_to_yaml(msg.charge_cutoff_current, out);
    out << ", ";
  }

  // member: fully_charged
  {
    out << "fully_charged: ";
    rosidl_generator_traits::value_to_yaml(msg.fully_charged, out);
    out << ", ";
  }

  // member: avg_temp
  {
    out << "avg_temp: ";
    rosidl_generator_traits::value_to_yaml(msg.avg_temp, out);
    out << ", ";
  }

  // member: discharge_cutoff_voltage
  {
    out << "discharge_cutoff_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.discharge_cutoff_voltage, out);
    out << ", ";
  }

  // member: charge_current_limit
  {
    out << "charge_current_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.charge_current_limit, out);
    out << ", ";
  }

  // member: max_voltage_allowed
  {
    out << "max_voltage_allowed: ";
    rosidl_generator_traits::value_to_yaml(msg.max_voltage_allowed, out);
    out << ", ";
  }

  // member: avg_health
  {
    out << "avg_health: ";
    rosidl_generator_traits::value_to_yaml(msg.avg_health, out);
    out << ", ";
  }

  // member: num_faulted_batteries
  {
    out << "num_faulted_batteries: ";
    rosidl_generator_traits::value_to_yaml(msg.num_faulted_batteries, out);
    out << ", ";
  }

  // member: num_active_batteries
  {
    out << "num_active_batteries: ";
    rosidl_generator_traits::value_to_yaml(msg.num_active_batteries, out);
    out << ", ";
  }

  // member: op_mode
  {
    out << "op_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.op_mode, out);
    out << ", ";
  }

  // member: charge_fault
  {
    out << "charge_fault: ";
    rosidl_generator_traits::value_to_yaml(msg.charge_fault, out);
    out << ", ";
  }

  // member: discharge_fault
  {
    out << "discharge_fault: ";
    rosidl_generator_traits::value_to_yaml(msg.discharge_fault, out);
    out << ", ";
  }

  // member: regen_current_limit
  {
    out << "regen_current_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.regen_current_limit, out);
    out << ", ";
  }

  // member: min_cell_voltage
  {
    out << "min_cell_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.min_cell_voltage, out);
    out << ", ";
  }

  // member: max_cell_voltage
  {
    out << "max_cell_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.max_cell_voltage, out);
    out << ", ";
  }

  // member: cell_balance_status
  {
    out << "cell_balance_status: ";
    rosidl_generator_traits::value_to_yaml(msg.cell_balance_status, out);
    out << ", ";
  }

  // member: all_avg_voltage
  {
    out << "all_avg_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.all_avg_voltage, out);
    out << ", ";
  }

  // member: all_soc
  {
    out << "all_soc: ";
    rosidl_generator_traits::value_to_yaml(msg.all_soc, out);
    out << ", ";
  }

  // member: all_avg_temp
  {
    out << "all_avg_temp: ";
    rosidl_generator_traits::value_to_yaml(msg.all_avg_temp, out);
    out << ", ";
  }

  // member: master_node_id
  {
    out << "master_node_id: ";
    rosidl_generator_traits::value_to_yaml(msg.master_node_id, out);
    out << ", ";
  }

  // member: avail_op_modes
  {
    out << "avail_op_modes: ";
    rosidl_generator_traits::value_to_yaml(msg.avail_op_modes, out);
    out << ", ";
  }

  // member: avail_charge_faults
  {
    out << "avail_charge_faults: ";
    rosidl_generator_traits::value_to_yaml(msg.avail_charge_faults, out);
    out << ", ";
  }

  // member: avail_discharge_faults
  {
    out << "avail_discharge_faults: ";
    rosidl_generator_traits::value_to_yaml(msg.avail_discharge_faults, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VirtualBattery & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: number_of_batteries
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_of_batteries: ";
    rosidl_generator_traits::value_to_yaml(msg.number_of_batteries, out);
    out << "\n";
  }

  // member: soc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "soc: ";
    rosidl_generator_traits::value_to_yaml(msg.soc, out);
    out << "\n";
  }

  // member: sum_capacity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sum_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.sum_capacity, out);
    out << "\n";
  }

  // member: remaining_runtime
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "remaining_runtime: ";
    rosidl_generator_traits::value_to_yaml(msg.remaining_runtime, out);
    out << "\n";
  }

  // member: remaining_chargetime
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "remaining_chargetime: ";
    rosidl_generator_traits::value_to_yaml(msg.remaining_chargetime, out);
    out << "\n";
  }

  // member: avg_voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "avg_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.avg_voltage, out);
    out << "\n";
  }

  // member: sum_current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sum_current: ";
    rosidl_generator_traits::value_to_yaml(msg.sum_current, out);
    out << "\n";
  }

  // member: discharge_current_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "discharge_current_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.discharge_current_limit, out);
    out << "\n";
  }

  // member: charge_cutoff_current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "charge_cutoff_current: ";
    rosidl_generator_traits::value_to_yaml(msg.charge_cutoff_current, out);
    out << "\n";
  }

  // member: fully_charged
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fully_charged: ";
    rosidl_generator_traits::value_to_yaml(msg.fully_charged, out);
    out << "\n";
  }

  // member: avg_temp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "avg_temp: ";
    rosidl_generator_traits::value_to_yaml(msg.avg_temp, out);
    out << "\n";
  }

  // member: discharge_cutoff_voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "discharge_cutoff_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.discharge_cutoff_voltage, out);
    out << "\n";
  }

  // member: charge_current_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "charge_current_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.charge_current_limit, out);
    out << "\n";
  }

  // member: max_voltage_allowed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_voltage_allowed: ";
    rosidl_generator_traits::value_to_yaml(msg.max_voltage_allowed, out);
    out << "\n";
  }

  // member: avg_health
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "avg_health: ";
    rosidl_generator_traits::value_to_yaml(msg.avg_health, out);
    out << "\n";
  }

  // member: num_faulted_batteries
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_faulted_batteries: ";
    rosidl_generator_traits::value_to_yaml(msg.num_faulted_batteries, out);
    out << "\n";
  }

  // member: num_active_batteries
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_active_batteries: ";
    rosidl_generator_traits::value_to_yaml(msg.num_active_batteries, out);
    out << "\n";
  }

  // member: op_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "op_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.op_mode, out);
    out << "\n";
  }

  // member: charge_fault
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "charge_fault: ";
    rosidl_generator_traits::value_to_yaml(msg.charge_fault, out);
    out << "\n";
  }

  // member: discharge_fault
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "discharge_fault: ";
    rosidl_generator_traits::value_to_yaml(msg.discharge_fault, out);
    out << "\n";
  }

  // member: regen_current_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "regen_current_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.regen_current_limit, out);
    out << "\n";
  }

  // member: min_cell_voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_cell_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.min_cell_voltage, out);
    out << "\n";
  }

  // member: max_cell_voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_cell_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.max_cell_voltage, out);
    out << "\n";
  }

  // member: cell_balance_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cell_balance_status: ";
    rosidl_generator_traits::value_to_yaml(msg.cell_balance_status, out);
    out << "\n";
  }

  // member: all_avg_voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "all_avg_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.all_avg_voltage, out);
    out << "\n";
  }

  // member: all_soc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "all_soc: ";
    rosidl_generator_traits::value_to_yaml(msg.all_soc, out);
    out << "\n";
  }

  // member: all_avg_temp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "all_avg_temp: ";
    rosidl_generator_traits::value_to_yaml(msg.all_avg_temp, out);
    out << "\n";
  }

  // member: master_node_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "master_node_id: ";
    rosidl_generator_traits::value_to_yaml(msg.master_node_id, out);
    out << "\n";
  }

  // member: avail_op_modes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "avail_op_modes: ";
    rosidl_generator_traits::value_to_yaml(msg.avail_op_modes, out);
    out << "\n";
  }

  // member: avail_charge_faults
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "avail_charge_faults: ";
    rosidl_generator_traits::value_to_yaml(msg.avail_charge_faults, out);
    out << "\n";
  }

  // member: avail_discharge_faults
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "avail_discharge_faults: ";
    rosidl_generator_traits::value_to_yaml(msg.avail_discharge_faults, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VirtualBattery & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace canopen_inventus_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use canopen_inventus_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const canopen_inventus_interfaces::msg::VirtualBattery & msg,
  std::ostream & out, size_t indentation = 0)
{
  canopen_inventus_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use canopen_inventus_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const canopen_inventus_interfaces::msg::VirtualBattery & msg)
{
  return canopen_inventus_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<canopen_inventus_interfaces::msg::VirtualBattery>()
{
  return "canopen_inventus_interfaces::msg::VirtualBattery";
}

template<>
inline const char * name<canopen_inventus_interfaces::msg::VirtualBattery>()
{
  return "canopen_inventus_interfaces/msg/VirtualBattery";
}

template<>
struct has_fixed_size<canopen_inventus_interfaces::msg::VirtualBattery>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<canopen_inventus_interfaces::msg::VirtualBattery>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<canopen_inventus_interfaces::msg::VirtualBattery>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // CANOPEN_INVENTUS_INTERFACES__MSG__DETAIL__VIRTUAL_BATTERY__TRAITS_HPP_
